<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00024000ModeloDocumentosFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function limparAnexoDoModelo(array $params) {
        $sql = "UPDATE FCT_MODELODOC
                   SET DSCAMINHOARQ = NULL,
                       NMARQUIVO    = NULL,
                       VRTAMANHO    = NULL,
                       DSTIPO       = NULL
                 WHERE NRSEQMODDOCFCT = :NRSEQMODDOCFCT
                   AND NRORG          = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function validarInativarModelo(array $params) {
        $sql = "SELECT ORCA.NRORCAMENTOMODELO from FCT_ORCAMENTOMODELO ORCA
                  JOIN FCT_RELACESCOPOMODELO RELAC ON ORCA.NRORCAMENTOMODELO = RELAC.NRORCAMENTOMODELO
                  JOIN FCT_ORCAESCOPODOC ESCOP ON RELAC.NRRELACESCOPOMODELO = ESCOP.NRRELACESCOPOMODELO
                 WHERE ORCA.NRORG = :NRORG
                   AND ESCOP.NRSEQMODDOCFCT = :NRSEQMODDOCFCT
                   AND ORCA.IDATIVO = 'S'
                   UNION
                  SELECT MODELO.NRSEQMODCONTRA FROM FCT_MODELOCONTRATO MODELO
                    JOIN FCT_MODELODOCCONTR CONT ON MODELO.NRSEQMODCONTRA = CONT.NRSEQMODCONTRA
                    JOIN FCT_MODELODOC DOC ON DOC.NRSEQMODDOCFCT = CONT.NRSEQMODDOCFCT
                   WHERE DOC.NRSEQMODDOCFCT = :NRSEQMODDOCFCT
                     AND MODELO.NRORG = :NRORG
                     AND MODELO.IDATIVO = 'S'";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();

    }
    
    /**
     * Busca as informações de um determinado documento
    **/
    public function getDocumento(array $params) {
        $sql = "SELECT NMARQUIVO,
                  VRTAMANHO,
                  DSCAMINHOARQ,
                  DSTIPO
                FROM FCT_MODELODOC
                WHERE NRSEQMODDOCFCT = :NRSEQMODDOCFCT
                  AND NRORG          = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>