-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 03/02/2004                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Altera o valor dos itens do pedido               --
-- ================================================================== --
/*  @C:\WIN_V4\SQL\END_CONV\ORACLE\2811_PEDSTPO.SQL  */
CREATE OR REPLACE PROCEDURE ALTERA_PRECOITENS(
   P_CDFILIAL      IN PEDIDO.CDFILIAL%TYPE,
   P_NRPEDIDO      IN PEDIDO.NRPEDIDO%TYPE,
   P_CDPRECOBASE   IN PRECOBASE.CDPRECOBASE%TYPE,
   P_NRERRO        OUT NUMBER
) IS

  V_VRITEPREBASE  NUMBER;
  V_VRDESITPED    NUMBER;
  V_VRPEDESC      NUMBER;
BEGIN
   P_NRERRO := 0;
   FOR C_ITEM IN
      (SELECT
          PE.CDFILIAL, PE.NRPEDIDO,   IT.NRITEMPED,  IT.CDPRODUTO,
          PE.DTPEDIDO, IT.VRDESITPED, IT.VRPREUNITPED
       FROM ITEMPEDIDO IT, PEDIDO PE
       WHERE PE.CDFILIAL    = P_CDFILIAL
         AND PE.NRPEDIDO    = P_NRPEDIDO
         AND IT.CDFILIAL    = PE.CDFILIAL
         AND IT.NRPEDIDO    = PE.NRPEDIDO
         AND IT.IDSITITEMPED IN ('1', '2')) LOOP


      SELECT MAX(VRITEPREBASE) INTO V_VRITEPREBASE
      FROM ITEMPREBASE
      WHERE CDPRECOBASE =  P_CDPRECOBASE
        AND CDPRODUTO   =  C_ITEM.CDPRODUTO;


      IF (V_VRITEPREBASE > 0) THEN
         V_VRDESITPED := C_ITEM.VRDESITPED;
         IF (C_ITEM.VRDESITPED > 0) THEN
            V_VRPEDESC   := (C_ITEM.VRDESITPED * 100)/C_ITEM.VRPREUNITPED;
            V_VRDESITPED := (V_VRITEPREBASE * V_VRPEDESC)/100;
         END IF;

         UPDATE ITEMPEDIDO
         SET VRPREUNITPED = V_VRITEPREBASE,
             VRPRTABITPED = V_VRITEPREBASE,
             VRDESITPED   = V_VRDESITPED
         WHERE CDFILIAL  = C_ITEM.CDFILIAL
           AND NRPEDIDO  = C_ITEM.NRPEDIDO
           AND NRITEMPED = C_ITEM.NRITEMPED;
      ELSE
         P_NRERRO := 1;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ALTERA_PRECOITENS','4.05.125'); END;
/

